'use strict';

var react = require('react');

function loadUser(uid, cb) { setTimeout(cb, 100, null, "User" + uid); }
function loadFile(filename, cb) { setTimeout(cb, 100, null, 'Filedata' + filename); }
function markdown(filedata) { return 'html' + filedata; }
function prepareDirectory(outDirname, cb) { setTimeout(cb, 200, null, 'dircreated-' + outDirname); }
function writeOutput(html, user, cb) {  setTimeout(cb, 300, null, html + '_bytesWritten'); }
function loadEmailTemplate(cb) { setTimeout(cb, 50, null, 'emailmd'); }
function customizeEmail(user, emailHtml, cb) { return 'cust-' + user + emailHtml; }
function deliverEmail(custEmailHtml, cb) { setTimeout(cb, 100, null, 'delivered-' + custEmailHtml); }

function useHtml(err, html, user, bytesWritten) {
  if (err) {
    console.log('***Error: %s', err);
    return;
  }
  console.log('final result: %s, user: %s, written:%s', html, user, bytesWritten);     
}



var fn = react(function (r, filename, uid, outDirname, cb) {
  var err, user, html, bytesWritten;
  r.sync(loadUser).in(uid).out(err, user)
    .cb(err, html, user, bytesWritten);
});


/*
var r = react();
    r.ast.inputNames = ['filename', 'uid', 'outDirname', 'cb'];
    r.ast.taskDefs = [
      { f:loadUser,          a:['uid'],               cb:['user'] },
      { f:loadFile,          a:['filename'],          cb:['filedata'] },
      { f:markdown,          a:['filedata'],          ret:['html'] },
      { f:prepareDirectory,  a:['outDirname'],        cb:['dircreated'] },
      { f:writeOutput,       a:['html', 'user'],      cb:['bytesWritten'],   after:['prepareDirectory'] },
      { f:loadEmailTemplate, a:[],                    cb:['emailmd'] },
      { f:markdown,          a:['emailmd'],           ret:['emailHtml'] },
      { f:customizeEmail,    a:['user', 'emailHtml'], ret:['custEmailHtml'] },
      { f:deliverEmail,      a:['custEmailHtml'],     cb:['deliveredEmail'], after:['writeOutput'] }
    ];
    r.ast.finalOutputNames = ['html', 'user', 'bytesWritten'];
*/

var fn = react(function (R, filename, uid, outDirname, cb) {

  //local vars used
  var filedata = R.var();
  var outDirName = R.var();
  var dircreated = R.var();
  var emailmd = R.var();
  var emailHtml = R.var();
  var custEmailHtml = R.var();
  var deliveredEmail = R.var();
  var err = R.var();
  var user = R.var();
  var html = R.var();
  var bytesWritten = R.var();
  
  R.out(err, html, user, bytesWritten)
    .async(loadUser, uid).cb(err, user)
    .async(loadFile, filename).cb(err, filedata)
    .sync(markdown, filedata).returns(filedata)
    .async(prepareDirectory, outDirName).cb(dircreated)
    .async(writeOutput, html, user).cb(err, bytesWritten).after(prepareDirectory)
    .async(loadEmailTemplate).cb(err, emailmd)
    .sync(markdown, emailmd).returns(emailHtml)
    .sync(customizeEmail, user, emailHtml).returns(custEmailHtml)
    .sync(deliverEmail, custEmailHtml).returns(deliveredEmail).after(writeOutput);
});
  
              
